UIPackage
Menu

Framework

Change language

Boilerplate repo

Button

buttonui

Interactive button component with variants (default, destructive, outline, secondary, ghost, link), sizes, and composite ButtonGroup container for segmented toolbars and split buttons.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/button.json
Named registry:npx shadcn@latest add @uipkge-react/buttonInstalls to:components/ui/button/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
variant
'default''destructive''outline''secondary''ghost''link'
defaultoptional
size
'default''sm''lg''xs''icon''icon-sm''icon-lg'
defaultoptional
asChild

emitting a <button> — the React equivalent of reka-ui's as-child. Use it to give a Next.js <Link> or <a> full button styling.

booleanfalseoptional

Used by

Files installed (4)

  • components/ui/button/Button.tsx1.2 kB
    import * as React from 'react'
    import { Slot } from '@radix-ui/react-slot'
    import { cn } from '@/lib/utils'
    import { buttonVariants, type ButtonVariants } from './button.variants'
    
    export interface ButtonProps extends React.ButtonHTMLAttributes<HTMLButtonElement>, ButtonVariants {
      /** Render the child element as the button (merging props/styles) instead of
       *  emitting a <button> — the React equivalent of reka-ui's as-child. Use it
       *  to give a Next.js <Link> or <a> full button styling. */
      asChild?: boolean
    }
    
    const Button = React.forwardRef<HTMLButtonElement, ButtonProps>(
      ({ className, variant = 'default', size = 'default', asChild = false, type = 'button', ...props }, ref) => {
        const Comp = asChild ? Slot : 'button'
        return (
          <Comp
            data-uipkge=""
            data-slot="button"
            data-variant={variant}
            data-size={size}
            className={cn(buttonVariants({ variant, size }), className)}
            // Default type="button" avoids accidental form submits. asChild leaves
            // type to the child (e.g. <a> / Next.js Link) and must not receive it.
            {...(asChild ? {} : { type })}
            ref={ref}
            {...props}
          />
        )
      },
    )
    Button.displayName = 'Button'
    
    export { Button }
    
  • components/ui/button/ButtonGroup.tsx3.6 kB
  • components/ui/button/button.variants.ts2.7 kB
  • components/ui/button/index.ts0.2 kB

Raw manifest:https://uipkge.dev/r/react/button.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Button

buttonui

Interactive button component with variants (default, destructive, outline, secondary, ghost, link), sizes, and composite ButtonGroup container for segmented toolbars and split buttons.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/button.json
Named registry:npx shadcn-vue@latest add @uipkge/buttonInstalls to:app/components/ui/button/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
asstring'button'optional
asChildbooleanoptional
variant
'default''destructive''outline''secondary''ghost''link'
'default'optional
size
'default''sm''lg''xs''icon''icon-sm''icon-lg''icon-xs''icon-2xs'
optional
type

Native button type. Defaults to `button` so forms are not submitted accidentally.

'button''submit''reset'
'button'optional
classHTMLAttributes['class']optional

Used by

Files installed (4)

  • app/components/ui/button/Button.vue1.7 kB
    <script setup lang="ts">
    import type { HTMLAttributes } from 'vue'
    import { Primitive } from 'reka-ui'
    import { cn } from '@/lib/utils'
    import { buttonVariants } from './button.variants'
    
    // Why inline these unions instead of `ButtonVariants['variant']` /
    // `ButtonVariants['size']`:
    //
    // `ButtonVariants` is `VariantProps<typeof buttonVariants>`. cva's
    // type machinery wraps the variant keys in a conditional + indexed
    // access (`{ [K in keyof Variants]?: ... }`), which Vue 3.5+'s SFC
    // compiler can't resolve. Result: defineProps<> silently drops
    // `variant`/`size` from the runtime declarations, every <Button
    // variant="ghost"> falls back to `default`, and SidebarTrigger
    // renders as a filled primary block.
    //
    // Inline the unions and Vue extracts them cleanly. The cva runtime
    // still validates against the same option set at runtime; we just
    // give the SFC compiler a type it can handle.
    type Variant = 'default' | 'destructive' | 'outline' | 'secondary' | 'ghost' | 'link'
    type Size = 'default' | 'sm' | 'lg' | 'xs' | 'icon' | 'icon-sm' | 'icon-lg' | 'icon-xs' | 'icon-2xs'
    
    interface Props {
      as?: string
      asChild?: boolean
      variant?: Variant
      size?: Size
      /** Native button type. Defaults to `button` so forms are not submitted accidentally. */
      type?: 'button' | 'submit' | 'reset'
      class?: HTMLAttributes['class']
    }
    
    const props = withDefaults(defineProps<Props>(), {
      as: 'button',
      type: 'button',
      variant: 'default',
    })
    </script>
    
    <template>
      <Primitive
        data-uipkge
        data-slot="button"
        :data-variant="variant"
        :data-size="size"
        :as="as"
        :as-child="asChild"
        :type="as === 'button' && !asChild ? type : undefined"
        :class="cn(buttonVariants({ variant, size }), props.class)"
      >
        <slot />
      </Primitive>
    </template>
    
  • app/components/ui/button/ButtonGroup.vue3.4 kB
  • app/components/ui/button/button.variants.ts2.7 kB
  • app/components/ui/button/index.ts0.2 kB

Raw manifest:https://uipkge.dev/r/vue/button.json